
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 *
 */

#ifndef DEFINE_DHASH_H
#define DEFINE_DHASH_H
class DHash
{
public:
	DHash (int asize = 256);
	~DHash ();
	bool set (char * KEY, char * DATA, int TYPE = DHASH_LPCHAR);
	bool set (char * KEY, long DATA, int TYPE = DHASH_INT);
	char * get (char * KEY);
	char * del (char * KEY);
	inline char ** get_keys () { return keys; }
	inline char ** get_values () { return values; }
	inline int * get_types () { return types; }
	inline int get_size () { return size; }
	void foreach (Dhash_f func);
	int from_file (char *f_name);

private:
	char ** keys;
	char ** values;
	int * types;
	int size;
};

#endif

