
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2005,2006,2007
 * graycardinalster@gmail.com
 *
 */

#ifndef DEFINE_GCLIB_H
#define DEFINE_GCLIB_H

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/time.h>
#include <string.h>
#include <dirent.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/mman.h>
#include <sys/poll.h>
#include <gclib/gclib_c.h>

#ifdef __cplusplus
typedef unsigned int uint32_t;
#define __export extern "C"
#else
#define __export extern
#endif
typedef unsigned char uchar_t;

#define PUT(arga) DROP(arga)
#define Dmemused mallinfo().uordblks
#define LPCHAR(arga) (char *) arga
#define DARRAY(arga) ((DArray *) arga)
#define container_of(var, type) ((type) var)
#define OBJECT(object,type) ((type) object)
#define DRET(type) ((type) cur_ret)
#define DSRET(ret) cur_ret = (long) ret;

#ifndef min
#define min(arga,argb) (arga < argb ? arga : argb)
#define max(arga,argb) (arga > argb ? arga : argb)
#endif

#define MAXSTRSIZE 256

typedef void (*Dfunc_t)(void *);
typedef void (*Dhash_f)(char *, char *);

enum DHASH_TYPES
{
	DHASH_LPCHAR,
	DHASH_INT,
	DHASH_OTHER
};

#include "dhash.h"
#include "darray.h"
#include "earray.h"
#include "dlist.h"
#include "elist.h"
#include "ehash.h"
#include "dheapsort.h"
#include "djobs.h"

struct dkey_t {
	char *KEY;
	char *VALUE;
};

#ifdef I_IN_DLIB_CODE
struct dirent * cur_dir_ent = NULL;
int cur_dir_fd = 0;
int cur_ret = 0;
#else
__export struct dirent * cur_dirent;
__export int cur_dir_fd;
__export int cur_ret;
#endif

__export DArray * Dfiles (char * path);
DArray * Dsplit (char * STR, char *ch); // 2005.
int Dsplit (char * STR, char *ch, DList * to_list); 
__export int Dsplit (char * buf, size_t buflen, char *str, EList * to_list);
__export int Dposix_fadvise (int fd, int offset, int len, int advice);

#undef __export
#define __export

#endif

