
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 *
 */

#include <gclib/gclib.h>

EList::EList ()
{
        pos = NULL;
}

EList::~EList ()
{
}

char * EList::get ()
{
        if (! pos)
                return NULL;
        else
                return pos->data;
}

char * EList::first ()
{
        pos = get_head ();
        return get ();
}

char * EList::last ()
{
        pos = get_tail ();
        return get ();
}

char * EList::next ()
{
        if (! pos->next)
                pos = NULL;
        else 
                pos = pos->next;
        return get ();
}

char * EList::prev ()
{
        if (! pos->prev)
                pos = NULL;
        else 
                pos = pos->prev;
        return get ();
}

char * EList::rm ()
{
        __dlist_entry_t *ptr;
        char * Ret;
        
        if (! pos)
                return NULL;

        ptr = pos;
        Ret = ptr->data;
        
        if (ptr->next)
                pos = ptr->next;
        else if (ptr->prev)
                pos = ptr->prev;	
        else 
                pos = NULL;
        
        DList::rm (ptr);
        return Ret;
}

EList & EList::operator << (char * S)
{
	add_tail (S);
	return *this;
}

bool EList::eol () 
{
	return pos ? false : true;
}

