
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2007
 * graycardinalster@gmail.com
 * 
 */ 

#include <head.h>
#include <TT.h>

int kindsFile (char * fileName, int type)
{
	TT * tt;
	char * op;
	int m_type;

	if (SB_FLGET (SB_FLDEBUG))
		logToFile (ENV->debug_file, (char *) "kindsFile: %s %d\n", fileName, type);

	tt = new TT;
	if (tt->loadFile (fileName) < 0) {
		delete tt;
		return -1;
	}

	if (tt->init () < 0) {
		delete tt;
		return -1;
	}

	while (true) {
		op = tt->nextOperator ();
		if (tt->ch == 0)
			break;

		if (! SB_FLGET (SB_FLCPP)) {
			if (tt->bracketDepth)
				continue;
		}

		m_type = tt->wit ();
		if (m_type & type)
			globalsPrint (tt->tt, tt->op (), m_type);
	}

	delete tt;
	return 0;
}



