
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2006
 * graycardinalster@gmail.com
 *
 */

#include <head.h>
#include <wit.h>
#include <mod.h>

void dumpOptions ()
{
	char * S;
	ENV->listOptions->first ();
	while ((S = ENV->listOptions->get ())) {
		printf ("%s ", S);
		ENV->listOptions->next ();
	}
	printf ("\n");
}

int opts_funcs (DArray * d_opts, int & i)
{
	char * opt;

	if (! d_opts)
		return -1;
	
	opt = d_opts->get (i);

	if (EQ (opt, "--help") || EQ (opt, "-h")) {
		usage ();
		exit (0);
	}
	
	if (EQ (opt, "-V") || EQ (opt, "--version")) {
		printf ("Silent Bob 1.7.6\n");
		exit (0);
	}
	
	if (EQ (opt, "--file")) {
		ENV->sb_cmd = cmd_file;
		return 0;
	}
	
	if (EQ (opt, "--the-tt")) {
		ENV->sb_cmd = cmd_the_tt;		
		return 0;
	}
	
	if (EQ (opt, "--structs")) {
		ENV->sb_cmd = cmd_give_structs;
		return 0;
	}
	
	if (EQ (opt, "--indent")) {
		ENV->sb_cmd = cmd_indent;
		return 0;
	}
	
	if (EQ (opt, "--tags")) {
		ENV->sb_cmd = cmd_tags;
		return 0;
	}
	
	if (EQ (opt, "--make-ctags") ||
			EQ (opt, "-c")) {
		ENV->sb_cmd = cmd_makectags;
		return 0;	
	}
	
	if (EQ (opt, "--call-tags") ||
			EQ (opt, "-ct")) {
		SB_FLSET (SB_FLTAGSTYLE); 
		ENV->sb_cmd = cmd_call_tags;
		return 0;
	}
	
	if (EQ (opt, "--cgrep")) {
		if (++i >= d_opts->get_size ())
			return 0;
		
		ENV->sb_cmd = cmd_cgrep;
		ENV->cgrep_exp = d_opts->get (i);
		return 0;
	}
	
	if (EQ (opt, "--tags")) {
		ENV->sb_cmd = cmd_tags;
		return 0;
	}

	if (EQ (opt, "-i")) {
		tags_interactive ();
		exit (0);
	}
	
	if (EQ (opt, "--cfiles") ||
			EQ (opt, "-f")) {
		bob_cfiles ();
		exit (0);
	}

	if (EQ (opt, "--time-test")) 
		Dtimer ();

	if (EQ (opt, "--plugins-viewer")) {
		plugins_viewer ();
		exit (0);
	}
	
	if (EQ (opt, "--options")) {
		dumpOptions ();
		exit (0);
	}

	return -1;
}

