
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * (c) Oleg Puchinin 2007
 * graycardinalster@gmail.com
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <gclib/gclib.h>
#include <gclib/gclib_c.h>
#include <mod.h>
#include <head.h>
#include <dbg.h>

extern "C" DArray * plugin_init (struct env_t *env);
struct env_t *ENV;

char simple_plugin_opt (DArray * d_opts, int * pos)
{
	int count;
	char * S;
	
	if (! d_opts || ! pos)
		return 0;

	count = d_opts->get_size ();
	S = d_opts->get (*pos);
	if (EQ (S, "--simple_plugin")) {
		if (++(*pos) >= count) 
			return 0; // Missed argument for option "--simple-plugin".
		// Do somethings.
	}

	return 0;
}

char simple_plugin_opt2 (DArray * d_opts, int * pos)
{
	char * S;
	
	if (! d_opts || ! pos)
		return 0;
	
	S = d_opts->get (*pos);
	if (EQ (S, "--simple_plugin")) {
		// Do somethings at stage two.
	}

	return 0;
}

void simple_plugin_short_info ()
{
	printf ("Simple plugin.");
}

void simple_plugin_long_info ()
{
	printf ("Simple plugin.\n");
	printf ("Version: 1.0\n");
	printf ("options: --simple-plugin\n");
}

DArray * plugin_init (struct env_t *env)
{
	DArray * Ret;
	mod_t * plug;

	Ret = new DArray (1);
	plug = CNEW (mod_t, 1);
	memset (plug, 0, sizeof (mod_t));

	plug->Version = strdup ("1.0");
	plug->short_info = simple_plugin_short_info;
	plug->long_info = simple_plugin_long_info;
	plug->opt = simple_plugin_opt;
	plug->opt2 = simple_plugin_opt2;

	Ret->add (LPCHAR (plug));
	return Ret;
}

